\documentclass[
	11pt, 
	DIV10,
	a4paper, 
	oneside, 
	headings=normal, 
	captions=tableheading,
	final, 
	numbers=noenddot
]{scrartcl}


\usepackage{amssymb}
\usepackage{graphicx}
\usepackage{sidecap}


\title{A Micropolar Material Model for Turbulent SPH Fluids}
\subtitle{\vspace{0.5cm}Seminar: Current Topics in Physically-Based Animation}
\author{Gregor Kobsik}


\begin{document}
\maketitle

\begin{figure}[h]
	\centering
	\includegraphics[width = 1\linewidth]{images/image1}
	\caption{\label{fig:image1} Our novel micropolar fluid model allows the simulation of complex turbulent fluids with static and dynamic boundaries.
		Left: A turbulent river with 12 million fluid particles flows through a complex static boundary. Right: One million fluid
		particles interact with a fast rotating propeller. \cite{bender2017micropolar}}
\end{figure}


\section{Abstract} 
The following report introduces the work of Jan Bender et al. on "A Micropolar Material Model for Turbulent SPH Fluids", which won the best paper award at the Eurographics Symposium on Computer Animation (SCA '17).
In this paper a novel micropolar material model for the simulation of turbulent inviscid fluids is introduced. The governing equations are discretized and solved with the principles of Smoothed Particle Hydrodynamics (SPH). Generally the Navier-Stokes equations form the basis for realistic fluid simulations, but due to numerical diffusion a loss of detail can be observed especially in highly turbulent scenes. To solve the problem a generalization of the classical Navier-Stokes equations is introduced: a micropolar fluid model, which considers the microrotation of the fluid particles to represent the vorticity field and provide a source for new vortices. However the classical micropolar material model in the field of mechanical engineering is designed to simulate viscous fluids and couple the rotational motion in a dissipative way. This is contrary to the goal of simulating turbulent inviscid fluids, therefore a modified version of this model is presented to fit flawlessly within the existing SPH frameworks. Furthermore the novel model can simulate realistic turbulences, while conserving the linear and angular momentum. Its computational overhead is negligible. \\

\section{Introduction}
This section starts with an compact overview of fluid simulation. Section 3 introduces related work on SPH fluids directed to numerical dissipation. Furthermore it presents the micropolar model and explains the shortcomings of the current state of the art. The following section introduces the Navier-Stokes equations, which form the predecessor for micropolar fluids. Section 5 explains the governing equations of the novel model and their derivation. The following sections introduce the discretization of the micropolar fluid model to fit the SPH concept and explain smoothing of the microrotation vector field to obtain larger vortices. Finally, the results will be presented and discussed according to existing SPH models in relation to appearance, stability and performance. \\

SPH is one of the major concepts for fluid animation in computer graphics. It allows for realistic and complex simulation with millions of particles and additional features like rigid bodies and foam at reasonable computational expenses \cite{ihmsen2014sph}. It is used for special effects in movies, which main focus is to simulate incompressible fluids in turbulent scenarios. \\

The Lagrangian approach of fluid simulation focuses on following specific tracer particles which represent the fluid as they move through time and space, while the Eulerian approach is fixed to specific points in space, e.g. a grid, which are computed to represent the fluid flow. Both approaches have been researched through the last years to improve the visual appearance and performance of the simulation. 

In the recent years new attempts for Lagrangian approaches enforcing the incompressibility of fluids have been introduced \cite{bender2017divergence}, but the simulation of realistic turbulent flow is still a challenging problem due to numerical diffusion \cite{de2015power} or a coarse sampling of the velocity field \cite{cornelis2014iisph, ihmsen2014sph}. Both aspects can negatively influence the visual liveliness of the flow.
In the field of the Eulerian approaches, especially in the field of smoke simulation, vorticity confinement has been introduced to neutralize the numerical dissipation and amplify existing vortices \cite{fedkiw2001visual}. Later this concept was adapted in SPH to counteract numerical damping \cite{macklin2013position}, but this amplification of acting forces is not momentum conserving and only existing vortices can be amplified. Lagrangian vortex methods are a further approach, as they maintain a divergence-free velocity field and have no numerical dissipation, but the handling of non rigid obstacles and free surface flows is challenging using these methods. \\

To overcome these limitations Bender et al. implement a SPH simulation method for incompressible turbulent fluids based on a micropolar material model introduced for mechanical engineering \cite{eringen1966theory}. It is a well studied generalization of the classical Navier-Stokes model for fluids, which additionally considers the microstructure of fluids resulting in a non-symmetric stress tensor \cite{eringenmicrocontinuum, lukaszewicz1999micropolar}. This additional consideration adds a rotational motion to each fluid particle, which adds a vorticity field to the governing equations, allowing the existence of vortices independently of the linear velocity field. Furthermore this field provides a source for new vortices \cite{eringenmicrocontinuum}. \\

However, the classical micropolar model is designed for viscous flow and couples the translational and rotational motion in a dissipative way. The need emerges to modify the existing model and provide new tensors to couple the motion in a non-dissipative way and allow for linear and angular momentum conservation in SPH simulation, as well. The novel model is meant to be used for the simulation of turbulent inviscid fluids and can be combined with any existing SPH pressure solver, while having a negligible computational overhead compared to classical approaches.


\section{Related Work}

In the following section the areas of related work are brought closer to the reader including the SPH model for fluids as well as the micropolar fluid model.
The shortcomings of the current state of the art are explained, such that the introduction of a new model is justified.

\subsection{SPH Fluids}

SPH is a numerical method used to solve continuum equations, like fluid flows. It was initially developed for astrophysical problems \cite{gingold1977smoothed, lucy1977numerical}, but today it is used in a broad field of research, including astrophysics, ballistics and oceanography \cite{marshall1997finite, sahu1985navier}. It is a mesh free Lagrangian method, which divides the fluid into a set of discrete elements, which are called particles. The properties of a certain point in space are smoothed by the weighted sum of all particles within the spatial distance, typically represented by $h$. The smoothing function is referred as a kernel function, e.g. the cubic spline \cite{monaghan1992smoothed, ihmsen2014sph}. The use of SPH for fluid simulations guarantees conservation of mass without additional computation, because every particle represents mass itself. An in detail report about SPH based fluids can be found in the state of the art report by Ihmsen et al. \cite{ihmsen2014sph}.
The development of efficient implicit pressure solvers was addressed in the recent years to enforce incompressibility in SPH simulations. Existing approaches can be categorized into two main methods, the first which iteratively projects particle positions onto an uncompressed state and second, pressure projection methods which make use of the divergence of the velocity field or the compression on position level as source term.\\

Current approaches which deal with the numerical dissipation of vortices within an fluid field can be mainly categorized into three fields: vorticity confinement, Lagrangian vortex and fluid-up sampling methods.

\subsubsection{Vorticity Confinement}
Vorticity Confinement was introduced by Fedkiw et al. \cite{fedkiw2001visual} in the field of Eulerian smoke simulation to solve the issue of numerical dissipation. It tries to find existing vortices and amplify them to counteract the numerical dissipation. Lentine et al. \cite{lentine2011mass} extended this work to archive energy conservation and momentum conserving vorticity confinement forces. A multilevel vorticity confinement approach was used by Jang et al. \cite{jang2010multilevel} to accomplish the creation of more turbulences in Eulerian water simulations. Zhu et al. \cite{zhu2010creating} used a hybrid method, in which fluids are simulated as SPH and an additional grid is used for vorticity confinement, to simulate small scale details in smoke around moving rigid bodies. Hong et al. \cite{hong2008bubbles} used vorticity confinement for the simulation of bubbles in water, where the water was simulated on a grid and the bubbles were SPH particles, which were animated with vorticity confinement to produce more turbulent behaviour. Macklin and M\"uller \cite{macklin2013position} determined the existing vorticity in purely particle based SPH approach and accelerated the particles to add rotational motion.
Bender states that the use of vorticity confinement directly on SPH particles can counteract the numerical dissipation in a simple way, but it is neither momentum nor energy conserving. A parameter that is responsible for the confinement can be chosen to high and add more energy then the numerical dissipation has removed. Furthermore no additional eddys can form from this method. These limitations are addressed with the micropolar fluid model, which is able to create additional turbulent details, without the need of other data structures, like Eulerian grids. Furthermore, it is linear and angular momentum conserving.

\subsubsection{Lagrangian Vortex Methods}
Turbulent details can be also simulated by the vorticity representation of the Navier-Stokes equations. It allows a compact representation of rotational flow, guarantees divergence-free velocity fields by default and does not suffer from numerical dissipation. The vorticity field can be discretized by particles \cite{park2005vortex,selle2005vortex}, curves and filaments \cite{angelidis2005simulation, weissmann20092} or surfaces and sheets \cite{pfaff2012lagrangian, weissmann2010filament}. et al. \cite{zhang2015restoring} presented a mixed vorticity and velocity based advection scheme to include the missing vorticity in SPH solvers.
Nevertheless the vortex representation struggles to handle boundaries as non-rigid obstacles and free surface flows. Therefore Golas et al. \cite{golas2012large} proposed a hybrid Eulerian and vorticity method, which uses Lagrangian vortex elements in the interior of the fluid and simulates the boundaries as an Eulerian grid. Furthermore the velocity field has to be recovered with Biot-Savart integrals or a vector valued Poisson equation \cite{zhang2014pppm}.
The micropolar fluid model and the Lagrangian vortex methods are coupled by the close relationship between vorticity and microrotations, but the micropolar model does not need to recover the velocity field due to the angular momentum equations. 

\subsubsection{Fluid-Up Sampling Methods}
A common approach in Eulerian smoke simulations is to use coarse grids for the simulation and increase the resolution afterwards by fine scale turbulence models \cite{kim2008wavelet, schechter2008evolving}. This approaches have been transferred to Eulerian liquid simulations \cite{kim2013closest, narain2008fast}. In the field of Lagrangian approaches, increasing the resolution of the velocity field \cite{shao2015realistic, yuan2012incorporating}, adding high frequency turbulent surface details \cite{mercier2015surface} and extending fluid surfaces with wave details \cite{yang2016enriching} was researched, too.
While the micropolar model counteracts the numerical dissipation, the fluid-up sampling methods address the problem of too coarse samplings by creating additional visual details. These methods are complementary to the micropolar fluid model and can be used on top of it, because most of them act as a post processing step.

\subsection{Micropolar Model}
The theory of micropolar continua was introduced by Eringen \cite{eringen1966theory} and it is a non-classical field theory for solid and fluid materials with a microstructure. The classical continuum mechanics assign a certain position to a particle at a certain time, irrespective of orientation, while micropolar material particles have assigned a director additionally, which defines the orientation of the particle \cite{pabst2005micropolar}. %check for error here
Micropolar fluids represent fluids, which consist of rigid, randomly oriented particles, that are suspended in a viscous medium (e.g. polymeric suspensions, animal blood, liquid crystals) \cite{lukaszewicz1999micropolar}. The deformation of those particles is ignored. 
The micropolar fluid model is therefore a generalization of the classical Navier-Stokes model, which adds only one new field, the angular velocity field, to describe the intrinsic movement of the fluid, thereby only one equation is added to represent the conservation of the angular momentum. 
A micropolar fluid follows the constitutive laws modelled using generally a non-symmetric stress tensor \cite{eringenmicrocontinuum}. \\

Consequently to the additional rotational motion of the infinitesimal small particles, the model has more degrees of freedom to represent a wider range of possible dynamic effects. Therefore Bender et al. used this model as a base to simulate vorticity within fluids like water, where the intrinsic particle motion acts as a source for new turbulent movement and facilitates the emergence of additional vortices.
An in depth introduction to the theory of micropolar fluids can be found in the textbooks of \L ukaszewicz \cite{lukaszewicz1999micropolar} and Eringen \cite{eringenmicrocontinuum}. \\

\section{Navier-Stokes Equations}

The Navier-Stokes equations describe the motion of viscous incompressible fluids. Furthermore they are a generalization of the simpler Euler equations, which describe the flow of inviscid fluids. They have a wide use in the modelling of weather or ocean currents, as well as the flow of water in a pipe or air around a wing \cite{jameson1998optimum}. They are usually written as
\begin{center}
	$ \frac{D v}{D t} = \frac{\partial v}{\partial t} + v \cdot \nabla v = - \frac{1}{\rho} \nabla p + \nu \Delta v + \frac{f}{\rho}$
\end{center}
\begin{center}
	$\nabla \cdot v = 0$
\end{center}
with $v$ as velocity (in literature also often denoted as $u$) and $\rho$ as density of the fluid, which is approximately $1000kg/m^3$ for water and $1.3kg/m^3$ for air \cite{bridson2007fluid}. The pressure is denoted with $p$, which is the force per unit that the fluid exerts on everything around it. Additional external forces, also called body forces, are summarized with $f$, mostly only the gravity force, e.g. $g = f / \rho$ with $9.81m/s^2$ is considered. The kinematic viscosity is denoted by the Greek letter $\nu$, which measures how viscous the fluid is, which describes the resistance of the fluid against deforming. \\

The first differential equation is particularly the Newton's equation $F = ma$, which tells us how the fluid accelerates according to the forces acting on it. To derive the equation, from Newton's second law to the Navier-Stokes equation, one can image the fluid to consist of particles, a control volume, with a mass $m$, a volume $V$ and a velocity $v$ \cite{bridson2007fluid}. The acceleration of a particle can be written as
\begin{center}
	$a \equiv \frac{D v}{D t}$
\end{center}
which is the material derivative of $v$. For an explanation on the material derivative see Appendix A. %add a ref instead of hard coded text
With this assumption the equation evolves to
\begin{center}
	$m \frac{D v}{D t} = F$.
\end{center}
The force in a fluid can be divided up into three main forces: the pressure force, the viscosity force and the gravity force $m g$.

High pressure regions push on low pressure regions, exerting a net force towards these regions. The imbalance in pressure can be measured with the negative gradient of pressure $- \nabla p$, which is integrated over the volume $V$ of the corresponding particle.

The second force is caused by the viscosity of a fluid, to resists deformation or try to move with the velocity of neighbouring particles trying to minimize the difference. The Laplacian $\Delta$ measures how much a quantity differs from the average around it. This value is integrated with the Volume and multiplied with the dynamic viscosity coefficient $\mu$, which describes how viscous the specific fluid is, resulting in the term $V \mu \Delta v$.

Substituting the force $F$ results in
\begin{center}
	$m \frac{D v}{D t} = - V \nabla p + V \mu \Delta v + m g$.
\end{center}
A fluid is a continuous size, therefore the limit of the equations causes the number of particles go to infinity. The volume as well as the mass of each one converges zero. The division of the equation with the volume solves the problem and a new quantity, the fluid density $ \rho = m / V$ is introduced
\begin{center}
	$\rho \frac{D v}{D t} = - \nabla p + \mu \Delta v + \rho g$.
\end{center}
By dividing with the density, defining the kinematic viscosity $\nu = \mu / \rho$ and generalizing the gravity force to body forces $f = \rho g$ the final equation is derived
\begin{center}
	$ \frac{D v}{D t} = - \frac{1}{\rho} \nabla p + \nu \Delta v + \frac{f}{\rho}$.
\end{center}
The model reduces to the Euler equations by choosing $\nu = 0$.\\

The second equation, which is the incompressibility condition, forces the fluid to stay at a constant volume.
To derive the equation one can use an arbitrary control volume $\Omega$ with a boundary surface $\partial \Omega$ \cite{bridson2007fluid}. The integration of the normal component of the fluid velocity around the boundary yields to volume change of the specific fluid. For incompressible fluids the rate of change should be zero
\begin{center}
	$\frac{d}{dt}Volume(\Omega) = \int \int_{\partial \Omega} v \cdot \hat{n} = 0$.
\end{center}
After applying the Divergence Theorem to change the area integral to a volume integral the equation evolves to
\begin{center}
	$\int \int \int_\Omega \nabla \cdot v = 0$.
\end{center}
The only function integrating to zero at every arbitrary position is zero itself resulting in
\begin{center}
	$\nabla \cdot v = 0$,
\end{center}
wherefore the incompressibility condition is also known as divergence-free velocity field.\\

The same formula for the momentum equation can be derived from the Cauchy momentum equation
\begin{center}
	$ \rho \frac{D v}{D t} = \nabla \cdot T + f$,
\end{center}
with a symmetric stress tensor defined as $T = -p I + \mu (\nabla v + (\nabla v)^T)$ and by applying the incompressibility condition.\\

\section{Governing Equations of Micropolar Fluid Model}

Micropolar material models for fluids have been researched in the field of mechanical engineering for the last decades, nevertheless the classical micropolar constitutive equations \cite{eringenmicrocontinuum, lukaszewicz1999micropolar} model viscous flow. Furthermore the coupling of translational and rotational motion is accomplished in a dissipative way, which is not desired for an inviscid or nearly inviscid flow. Consequently Bender et al. derived a modified micropolar material model, that fits the needs of simulating incompressible inviscid turbulent fluids.
In the following sections these derived equations will be presented and explained.

\subsection{Linear and Angular Momentum Conservation and Incompressibility}
The equations for linear and angular motion are derived analogously to the Navier-Stokes model, where a three dimensional fluid is described by a density field $\rho$ : $\mathbb{R}^3 \to \mathbb{R}$ and a velocity field: $v$ : $\mathbb{R}^3 \times [0,\infty) \to \mathbb{R}^3$ that maps a point $x$ at time $t$ to its velocity vector. Additionally the model is influenced by a microrotation field $\omega$ : $\mathbb{R}^3 \times [0, \infty) \to \mathbb{R}^3$ that maps a point $x$ at time $t$ to its angular velocity. The laws for conservation of linear and angular momentum are defined as
\begin{equation}
	\label{eq:one}
	\rho \frac{D v}{D t} = \nabla \cdot T + f
\end{equation}
\begin{equation}
	\label{eq:two}
	\rho \Theta \frac{D \omega}{D t} = \nabla \cdot C + T_{\times} + \tau
\end{equation}
with $[T_{\times}]_{i} = \sum_j \sum_k \epsilon_{ijk}T_{jk} = 
\left(
	\begin{array} {c}
	t_{23} - t_{32} \\
	t_{31} - t_{13} \\
	t_{12} - t_{21} \\
	\end{array}
\right)
$
where $T$, $f$ and $\epsilon_{ijk}$ represent the stress tensor, the specific external force and the Levi-Civita symbol, as well as $\Theta$, $\tau$ and $C$, the microinertia coefficient, the specific external torque and the couple stress tensor, respectively. The microinertia coefficient can be interpreted as a certain resistance against rotational acceleration of each infinitesimal fluid particle. The quantity can be measured experimentally using Lagrangian velocities of tracer particles \cite{chen2010theory}, but Bender decided to estimate the value by comparing different examples and set the value of $\Theta = 2$ in all results, based on his experience. The value of $\Theta$ is independent of the SPH particle size, because it appears in the continuous equation before the discretization.
To model incompressible fluids the fluid's density $\rho$ should not change over time resulting in
\begin{equation}
	\label{eq:three}
	\frac{D \rho}{D t} = - \rho \nabla \cdot v = 0,
\end{equation}
which implies that the velocity field must be divergence free: $\nabla \cdot v = 0$.

\subsection{Constitutive Model}

Bender et al. propose a novel constitutive model for inviscid and low-viscous fluids, that generalizes the Navier-Stokes equations. The stress tensor $T \in \mathbb{R}^{3 \times 3}$ and the coupling tensor $C \in \mathbb{R}^{3 \times 3}$ are defined as
\begin{equation}
	\label{eq:four}
	T = -pI + \mu (\nabla v)^T - \mu_t\nabla v + (\mu + \mu_t)\omega^{\times}
\end{equation}
\begin{equation}
	\label{eq:five}
	C = c (\nabla \omega)^{T}
\end{equation}
with $[\omega^{\times}]_{jk} = \sum_{i} \epsilon_{jik} \omega_{i} = 
\left(
\begin{array} {ccc}
0 & -\omega_3 & \omega_2 \\
\omega_3 & 0 & -\omega_1 \\
-\omega_2 & \omega_1 & 0 \\
\end{array}
\right)
$. 
The pressure and the identity matrix is denoted by $p$ and $I$. The pressure term is responsible for counteracting compression and builds the basis of fluid material models. In contrast to the classical Navier-Stokes equation, where viscosity is modelled with a symmetric second order tensor, i.e. $\mu(\nabla v + (\nabla v)^T)$, the tensor representation is decoupled and provides individual parameters for the dynamic viscosity $\mu$ and the transfer coefficient $\mu_t$. These material parameters must satisfy the following inequalities to be consistent with the second law of thermodynamics: $\mu \ge 0$ and $\mu_t \ge -\mu$ to ensure that the terms will only dissipate and never produce energy. The transformation from rotational into linear motion and vice versa is done by the last term $(\mu + \mu_t)\omega^{\times}$. Moreover, physically this term represent the friction between the infinitesimal particles in the fluid. The coupling tensor $C$ is only dependent the microinertia gradient and the dynamic rotational viscosity parameter $c$.

\subsection{Equation of Motion}
After defining the conservation laws and constitutive equations the equations of motion can be derived. The constitutive equations (\ref{eq:four}) and (\ref{eq:five}) are plugged into (\ref{eq:one}) and (\ref{eq:two}). Once the distributive rule is applied to the nabla operator and the equations are reshaped as shown in (\ref{eq:six}) and (\ref{eq:seven}) by applying the incompressibility equation (\ref{eq:three})
\begin{equation}
	\label{eq:six}
	\nabla \cdot (\nabla v) = \nabla \cdot (\nabla \otimes v)^T 
	= 
	\left(
	\begin{array} {c}
	\frac{\partial}{\partial x} (	\frac{\partial v_x}{\partial x} + \frac{\partial v_y}{\partial y} + \frac{\partial v_z}{\partial z} )\\
	\frac{\partial}{\partial y} (	\frac{\partial v_x}{\partial x} + \frac{\partial v_y}{\partial y} + \frac{\partial v_z}{\partial z} )\\
	\frac{\partial}{\partial z} (	\frac{\partial v_x}{\partial x} + \frac{\partial v_y}{\partial y} + \frac{\partial v_z}{\partial z} )\\
	\end{array}
	\right)
	=^{(\ref{eq:three})}
	\left(
	\begin{array} {c}
	\frac{\partial}{\partial x}  0\\
	\frac{\partial}{\partial y}  0\\
	\frac{\partial}{\partial z}  0\\
	\end{array}
	\right)
	=
	\left(
	\begin{array} {c}
	0\\
	0\\
	0\\
	\end{array}
	\right)
\end{equation}
\begin{equation}
	\label{eq:seven}
	\nabla \cdot (\nabla v)^T 
	=
	\left(
	\begin{array} {c}
	\frac{\partial v_x}{\partial x^2} + \frac{\partial v_x}{\partial y^2} + \frac{\partial v_x}{\partial z^2} \\
	\frac{\partial v_y}{\partial x^2} + \frac{\partial v_y}{\partial y^2} + \frac{\partial v_y}{\partial z^2} \\
	\frac{\partial v_z}{\partial x^2} + \frac{\partial v_z}{\partial y^2} + \frac{\partial v_z}{\partial z^2} \\
	\end{array}
	\right)
	=
	\frac{\partial}{\partial x^2} v + \frac{\partial}{\partial y^2} v + \frac{\partial}{\partial z^2} v
	=
	\Delta v
\end{equation}
one arrives at the following representation of the equations of motion
\begin{equation}
	\label{eq:eight}
	\frac{D v}{D t} = - \frac{1}{\rho} \nabla p + \nu \Delta v + (\nu + \nu_t) \nabla \times \omega + \frac{f}{\rho}
\end{equation}

\begin{equation}
	\label{eq:nine}
	\Theta \frac{D \omega}{D t} = \xi \Delta \omega + ( \nu + \nu_t) (\nabla \times v - 2 \omega) + \frac{\tau}{\rho}
\end{equation}
with $\nu = \frac{\mu}{\rho}$, $\nu_t = \frac{\mu_t}{\rho}$ and $\xi = \frac{c}{\rho}$ denoting the kinematic viscosity, the kinematic transfer coefficient and the kinematic rotational viscosity, respectively. It can be easily shown that the micropolar fluid model is a generalization of the classical Navier-Stokes equation by applying $\nu_t = -  \nu$, $\xi = 0$ and $\tau = 0$. \\

Bender states that the transfer between rotational and linear motion in the model imposed by $\nu_t$, in contrast to $\nu$, is non-dissipative, because the coefficient is not included in the diffusive terms.
To model inviscid fluids one can reduce the model by choosing $\nu = 0$ and $\xi = 0$, which results finally in
\begin{equation}
\label{eq:ten}
\frac{D v}{D t} = - \frac{1}{\rho} \nabla p + \nu_t \nabla \times \omega + \frac{f}{\rho}
\end{equation}
\begin{equation}
\label{eq:eleven}
\Theta \frac{D \omega}{D t} =\nu_t (\nabla \times v - 2 \omega) + \frac{\tau}{\rho}.
\end{equation}

\section{SPH Discretization}

The derived governing equations of motion will be discretized using the Smoothed Particles Hydrodynamics approach to compute the density, the pressure term, the transfer term and the viscosity terms (if required).
In SPH the density $\rho_i$ at a position $x_i$ is computed by
\begin{center}
	$\rho_i = \sum_{j}m_jW_{ij}$,
\end{center}
where $m_j$ denotes the mass of the neighbouring particle $j$ and $W_{ij} = W(x_i - x_j, h)$ denotes the smoothing kernel with the smoothing length $h$. Jan Bender uses the cubic spline kernel \cite{monaghan1992smoothed}, but other kernel functions are possible as well.
To simulate incompressible fluids an implicit pressure solver is chosen, but the approach is combinable with any SPH pressure solver. The model was successfully tested with the pressure solvers PBF \cite{macklin2013position}, IISPH \cite{ihmsen2014implicit}, DFSPH \cite{bender2017divergence}. \\

To compute the transfer terms the curl of the linear and angular velocity field has to be determined. When energy is added to the system to amplify existing vortices the difference curl operator \cite{monaghan1992smoothed} is used often, but the symmetric curl operator is used to obtain energy conservation \cite{price2010smoothed}:
\begin{center}
	$(\nabla \times A)_i = - \rho_i \sum_j m_j \left( \frac{A_i}{\rho_i^2} + \frac{A_j}{\rho_j^2} \right) \times \nabla_iW_{ij}$.
\end{center}
Although Bender is interested in simulating inviscid fluids, the Laplacian of the viscosity in terms (\ref{eq:six}) and (\ref{eq:seven}) can by determined by using the following SPH approximation \cite{ihmsen2014implicit, monaghan1992smoothed}:
\begin{center}
	$ \Delta A_i = 2 \sum_j \frac{m_j}{\rho_j} A_{ij} \frac{x_ij \cdot \nabla W_{ij}}{\Vert x_{ij} \Vert^2 + 0.01h^2}$,
\end{center}
with $x_{ij} = x_i - x_j$ to compute the viscosity terms $\nu \Delta v$ and $\xi \Delta \omega$.

\section{Smoothing the Velocity Fields}
In the simulation of inviscid fluids with SPH, particles can pass through each other causing a physically unrealistic state, caused by a locally multi-valued field \cite{monaghan1989problem,monaghan2002sph}. Monaghan solves the problem by introducing smoothing of the linear velocity field, known as XSPH \cite{monaghan1992smoothed}, so that particles close to each other move with almost identical velocities. This method is linear and angular momentum conserving. It is used to smooth out details and introduces artificial viscosity to make the fluid look viscous, while being non-dissipative. Bender uses this method to transfer the velocity of a particle to its neighbours in the absence of viscosity. He proposes to use a low coefficient $\epsilon$ to preserve details.\\

In XSPH the smoothed velocity $\hat{v}_i$ is computed as
\begin{center}
	$\hat{v}_i = v_i + \epsilon \sum_j \frac{m_j}{\rho_j} (v_j - v_i) W_{ij}$
\end{center}
with $ 0 \le \epsilon \le 1$ as a tunable parameter. 
In the micropolar fluid model a new field, the angular velocity field is introduced. Therefore the smoothed angular velocity is defined analogously as
\begin{center}
	$\hat{\omega}_i = \omega_i + \eta \sum_j \frac{m_j}{\rho_j} (\omega_j - \omega_i) W_{ij}$
\end{center}
where $0 \le \eta \le 1$ is a newly introduced coefficient to control the amount of smoothed vorticity. While the original XSPH prevents particles from passing each other, the XSPH variant for angular velocities transfers the angular vorticity to neighbouring particles, allowing to create larger vortices in absence of viscosity.

\section{Results}

This section will present results of the novel micropolar fluid model and compare them with the classical Navier-Stokes model. To perform the simulation, the micropolar model was implemented into the open-source fluid library SPlishSplaSH \cite{bender20017splisplash}, with the parallel neighbourhood search algorithm introduced by Ihmsen et al. \cite{ihmsen2011parallel}, the boundary handling by Akinci et al. \cite{akinci2012versatile} and an adaptive time-stepping based on the Courant-Friedrichs-Lewy (CFL) condition. All results are computed with the DFSPH pressure solver \cite{bender2017divergence}, with and average volume deviation of less then 0.01 \% and a divergence-error of less then 0.1 \%. To simulate inviscid fluids the kinematic viscosity $\mu$ and the kinematic rotational viscosity $\xi$ are set to 0. XSPH is used to smooth the linear and angular field. To prevent the fluid from looking viscous Bender uses $\epsilon = 0.002$ and to get larger vertices $\eta$ is set to $0.125$. Furthermore $\Theta = 2$ was chosen as described in section 4.1. \\

In this section CSPH is used as an abbreviation for the classical Navier-Stokes SPH method using DFSPH \cite{bender2017divergence} with XSPH \cite{monaghan1992smoothed}, and VCSPH if additional vorticity confinement forces \cite{macklin2013position} are computed. The abbreviation MPSPH is used to denote simulations with the micropolar fluid model with smoothed velocity fields.

\subsection{Lid-Driven Cavity}
The lid-driven cavity scenario is a standard benchmark in computational fluid dynamics \cite{ghia1982high}, which is a 2D problem consisting of a square cavity with edge lengths $L = 1$m, that is completely filled with a fluid. The fluid is accelerated by a horizontally moving lid resulting in a fluid velocity of $\vert v \vert = 1$m/s in horizontal direction at the upper boundary. No split conditions are applied at the remaining boundaries. Cummins and Rudman described how to enforce those conditions \cite{cummins1999sph}. For each fluid particle $i$ that is closer then the support radius to the boundary, a ghost particle is created by reflecting the particle at the boundary. Its velocity $v^g_i$ is set to $v^g_i = 2v^b - v_i$, such that the interpolated velocity at the boundary becomes $v^b$. Further there is no gravity. In the simulation 12k fluid particles filled the cave completely. The 2D cubic spline kernel \cite{monaghan1992smoothed} is used. The kinematic viscosity $\nu$ is chosen to get a Reynolds number of 10000, which was used by Ghia et al. \cite{ghia1982high}.\\

\begin{figure}
	\centering
	\includegraphics[width = 1\linewidth]{images/image2}
	\caption{\label{fig:image2} Velocity fields of the lid-driven cavity benchmark. CSPH (left) and VCSPH (middle) produce only one large central
		vortex. In contrast MPSPH (right) shows the expected results. It produces the central vortex and three smaller vortices in the
		corners which are rotating in the opposite direction. \cite{bender2017micropolar}}
\end{figure}

Ghia et al. presented with a multi-grid finite-difference solver, that the system should develop a steady flow. Therefore it is expected to find one large vortex in the centre and and three smaller vortices in the corners of the cavity rotating in the opposite direction of the main vortex. Figure \ref{fig:image2} shows the resulting velocity fields of CSPH (left), VCSPH (middle) and MPSPH (right). These velocity fields were obtained by simulating the scenario for a longer period of time until it developed a steady flow.

CSPH creates a large central vortex, but no additional vortices in the corners. Bender et al. assume that the numerical diffusion  of SPH is to blame, which was already discussed in previous works on SPH \cite{cornelis2014iisph,de2015power,ihmsen2014implicit}.

VCSPH creates similar results since the method only amplifies existing vortices, but does not create new ones. Different values of the confinement parameter $\epsilon$ were tested by Bender et al., but all lead to the same result of one central vortex differentiating only in its speed. Figure \ref{fig:image2} shows the velocity field with $\epsilon$ set to $0.1$.

MPSPH shows, in contrast to the previous two results, one central vortex and three smaller ones. One is located in the top left corner, the other two are positioned in the bottom corners, all three rotating in the opposite direction of then main vortex. In MPSPH the vorticity of the velocity field induces microrotations, which are advected along the particle motion and are neither prone to numerical dissipation nor the projection into a divergence-free field. These microrotations produce new vortices. Additionally microrotations are transported to neighbouring particles through XSPH leading to larger vortices. The micropolar fluid model can represent vorticity even in a single particle, where the classical approach needs to extract the rotational motion of the fluid from the linear movement of the particles neighbourhood. Furthermore, in contrast to VCSPH micropolar fluids are linear and angular momentum conserving by construction. MPSPH is therefore, compared to other SPH simulation methods, more  suited to simulate turbulent movement of fluids, because microrotations allow for more complex interactions between the particles.

\subsection{Comparisons}

\begin{SCfigure}
	\centering
	\includegraphics[width = 0.5\linewidth]{images/image3}
	\caption{\label{fig:image3} 	
		Breaking dam with 1M fluid particles and a static
		spherical obstacle simulated with four different transfer coefficients (from top to bottom):$\nu_t = 0.0, \nu_t = 0.05, \nu_t = 0.075$
		and $\nu_t = 0.1$. The linear particle velocity is color coded, white
		refers to high and blue to low velocity.	
		\cite{bender2017micropolar}
	}
\end{SCfigure}

The influence of the transfer coefficient $\nu_t$ can be visualised by simulating the same scene with an increasing value of the coefficient. Figure \ref{fig:image3} shows this case in a dam break scenario with 1 million fluid particles and a half sphere as a static object. A block of water is initialized at the left side of the scene. After the start of the simulation the water falls down due to gravity and flows around the sphere to the right side of the scene. The first scene (top) a classical SPH simulation is produced by setting $\nu_t = 0$, wherefore no microrotations are induced to the particles. The coefficient is increased from top to bottom showing more turbulent details on the right side of the scene. This proves, that the numerical dissipation of classical SPH methods is countered by the micropolar model. Furthermore, it demonstrates that the vorticity of the fluid can be controlled intuitively by one parameter.\\

CSPH (top), VCSPH (middle) and MPSPH with $\nu_t = 0.05$ (bottom) are also compared in the same scenario in Figure \ref{fig:image4}. It is clearly visible, that vorticity confinement method of Macklin and M\"uller \cite{macklin2013position} adds energy to the system, resulting in a fast flow of water, while the micropolar fluids model produces no additional energy and therefore acts in a physically consistent way. Bender states that in the end of the accompanying video one can clearly see that VCSPH only amplifies existing vortices, while the micropolar model also provides a source for new ones.

\subsection{Stability}

To demonstrate the stability of the micropolar fluid model Bender et al. simulate a scene with 1 million fluid particles and a propeller accelerating this fluid by rotating at 150 revolutions per minute. This set up leads to a highly turbulent motion of the particles which is realistically handled by this approach (e.g. Figure \ref{fig:image1}). The motion of the propeller was simulated using the implementation of position-based rigid body dynamics \cite{deul2016position} in the open-source library PositionBasedDynamics \cite{bender20017positionBasedDynamicLibrary}. \\

\begin{SCfigure}
	\centering
	\includegraphics[width = 0.5\linewidth]{images/image4}
	\caption{\label{fig:image4} 	
		Comparison of CSPH (top), VCSPH (middle) and
		MPSPH with $\nu_t = 0.05$ (bottom) in the dam break scenario
		with static spherical obstacle. Vorticity confinement adds energy
		to the fluid, which results in a much faster flow. In contrast
		MPSPH treats energy in a physically consistent way.	
		\cite{bender2017micropolar}	
	}
\end{SCfigure}

Figure \ref{fig:image5} shows the same scene as a particle view for CSPH (top) and MPSPH with different transfer coefficients $\nu_t = 0.2$ (middle) and $ \nu_t = 0.3$ (bottom). In the classical approach the details get quickly lost due to numerical diffusion and the whirls do not reach the right side of the scene, however in the MPSPH simulation the turbulences are propagated farther to the right of the scene resulting in a more lively simulation of the fluid.

\subsection{Performance}

The last example compares the computational time between CSPH and MPSPH in a scene, with 1 million fluid particles and three static Stanford dragons, showed in Figure \ref{fig:image6}. An Intel Xeon E5-2683 with 16 cores each at 2,1 GHz was used to compute and measure the simulation. The results state that the most time consuming part of the computation is the neighbourhood search and the implicit pressure solver. The computational overhead was only 5\% compared to CSPH. The computation of microrotations in the micropolar fluid model only has a linear time complexity. The neighbourhood search and the pressure solver require proportionally more time compared to the computational time of microrotations. This becomes even more visible in a complex scene of a river with 12 million particles (e.g. Figure \ref{fig:image1}).

\section{Conclusion}

The proposed micropolar fluid model by Bender et al. is the first approach in the field of computer graphics to consider the micropolar material property and additionally to implement this within a SPH framework. It provides a more realistic and turbulent appearance of the fluid controlled mainly by only one additional parameter, the velocity transfer coefficient $\mu_t$. This parameter controls the transfer of linear into angular momentum and vice versa allowing the infinitesimal particles to carry rotational motion. These microrotations form a source for the creation of new vortices and counteract numerical dissipation while conserving the energy within the fluid system. It adds liveliness and turbulent details to the scene. This novel model is simultaneously a generalisation of the well known Navier-Stokes model allowing the simulation of viscid and inviscid fluids. The SPH discretization of this model can be easily implemented within today SPH pressure solvers and does not carry any additional limitations beyond the limitations of the existing SPH based fluid solvers \cite{bender2017divergence, ihmsen2014implicit}. Bender showed in his experiments, that this model is capable of creating physically meaningful results while handling large-scale scenarios with millions of particles robustly and maintaining a negligible computational overhead.

In future work Bender is interested in investigating microstructural models for other complex materials, because the micropolar model is defined not only for liquids, but for solids as well. The simulation of elastic solids would be the next field of research. 

\begin{SCfigure}
	\centering
	\includegraphics[width = 0.5\linewidth]{images/image5}
	\caption{\label{fig:image5} 	
		Propeller scene from Figure \ref{fig:image1} rendered as particles
		with color coded linear velocities. The propeller in the left
		of the scene generates high fluid velocities and highly turbulent
		motion. Using CSPH (top) only a few turbulences reach
		the right part of the scene due to numerical diffusion. MPSPH
		with $\nu_t = 0.2$ (middle) and with $\nu_t = 0.3$ (bottom) results
		in much more turbulent motion and turbulences are transported
		farther to the right.	
		\cite{bender2017micropolar}	
	}
\end{SCfigure}

\section{Appendix A}

\subsection{Material Derivative}

A material derivative describes a time rate change of a physical quantity of a material, which is influenced by the velocity field. It connects the Eulerian and Lagrangian viewpoints \cite{bridson2007fluid}. \\

The function $q(t,x)$ is defined as a value of $q$, that can be an attribute hold by a particle at the position $x$ and the time $t$. The change rate is the defined as
\begin{center}
	$\frac{d}{d t} q(t,x)$.
\end{center}
After applying the Chain Rule to the formula one can derive the equation
\begin{center}
	$\frac{d}{d t} q(t,x) 
	= \frac{\partial q}{\partial t} + \nabla q \cdot \frac{d x}{d t} 
	= \frac{\partial q}{\partial t} + \nabla q \cdot v 
	\equiv \frac{D q}{D t}$.
\end{center}

The first term $\partial q / \partial t$ describes how fast the value $q$ is changing at that fixed point in space, while the second term $\nabla q \cdot v$ corrects the change that is caused by the flow of the fluid. \\

A material derivative which is set to zero $D q / D t = 0$, means that the particle with a quantity $q$ is moving with the velocity field $v$, but its value is not changing.

\subsection{Vector Calculus}

The nabla operator $\nabla$ is a common function in the field of fluid dynamics. It is used to denote the gradient $\nabla$, the divergence $\nabla \cdot$ and the curl $\nabla \times$. An easily accessible report at the use of the operator and special notation conventions in the field of fluid simulation can by found in the appendix A of the fluid simulation notes of Bridson and M\"uller \cite{bridson2007fluid}. 

\begin{figure} [tb]
	\centering
	\includegraphics[width = 1\linewidth]{images/image6}
	\caption{\label{fig:image6} 		
		Breaking dam scenario with 1M fluid particles and
		three static obstacles.
		\cite{bender2017micropolar}
	}
\end{figure}

\bibliographystyle{alpha}
\bibliography{references}

\end{document}          
